import pygame
import random

pygame.init()

SCREEN_WIDTH = 300
SCREEN_HEIGHT = 300
SCREEN_COLOR = (255,255,255)

WIN = 1
LOSE = 2
EQUAL = 3

class Player(pygame.sprite.Sprite):

    font = pygame.font.SysFont("Comic Sans", 50)
    options = ["M", "K", "L"]
    color = (0,0,255)

    def __init__(self, postition):

        super().__init__()
        self.image = self.font.render("X", True, self.color)
        self.rect = self.image.get_rect(topleft=postition)
        self.value ="X"

    #metod za azuriranje stanja potrebnih za prikaz izabrane opcije
    def change(self):
        self.image = self.font.render(self.value,  True, self.color)
        self.rect = self.image.get_rect(topleft=self.rect.topleft)


class UserPlayer(Player):

    def __init__(self, postition):
        super().__init__(postition)

    #metod za azuriranje stanja
    def update(self, value):
        self.value = value
        self.change()

    def fin(self, computer):

        if self.value == computer.value:
            return  EQUAL

        if (self.value =="M" and computer.value=="L") or \
            (self.value == "K" and computer.value == "M") or \
            (self.value == "L" and computer.value == "K"):
            return WIN

        return  LOSE


class ComputerPlayer(Player):

    def __init__(self, postition):
        super().__init__(postition)

    #metod za azuriranje stanja
    def update(self):
        self.value = self.options[random.randint(0, len(self.options)-1)]
        self.change()


def play(user, computer, option):
    user.update(option)
    computer.update()

    if user.fin(computer) == WIN:
        return "POBEDA"
    elif user.fin(computer) == EQUAL:
        return "IZJEDNACENO"
    else:
        return "GUBITAK"

screen = pygame.display.set_mode((SCREEN_WIDTH, SCREEN_HEIGHT))
screen.fill(SCREEN_COLOR)
pygame.display.set_caption("Makaze kamen list")

running = True

user = UserPlayer((SCREEN_WIDTH/2,SCREEN_HEIGHT/2))
computer = ComputerPlayer((10,10))

all_sprites = pygame.sprite.Group()
all_sprites.add(user)
all_sprites.add(computer)

font = pygame.font.SysFont("Comic Sans", 35)
message="Igraj (K,M,N)"

all_sprites.draw(screen)
text = font.render(message, True, (0, 255, 0))
screen.blit(text, text.get_rect(bottomright=(SCREEN_WIDTH, SCREEN_HEIGHT)))
pygame.display.update()


while running:

    for event in pygame.event.get():

        if event.type == pygame.QUIT:
            running = False

        elif event.type == pygame.KEYDOWN:
            if event.key == pygame.K_ESCAPE:
                running = False
                message="Bye-Bye"

            elif event.key ==  pygame.K_m:
                message=play(user, computer, "M")

            elif event.key ==  pygame.K_k:
                message=play(user, computer, "K")

            elif event.key ==  pygame.K_l:
                message=play(user, computer, "L")


            screen.fill(SCREEN_COLOR)
            all_sprites.draw(screen)
            text = font.render(message, True, (0,255,0))
            screen.blit(text, text.get_rect(bottomright=(SCREEN_WIDTH,SCREEN_HEIGHT)))

            pygame.display.update()

pygame.quit()